﻿Imports System.ComponentModel
Public Class Customer
    Implements INotifyPropertyChanged

    Private _strName As String = String.Empty
    Private _strState As String = String.Empty
    Private _strEmail As String = String.Empty

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Public Property Name As String
        Get
            Return _strName
        End Get
        Set(ByVal value As String)
            _strName = value
            OnPropertyChanged("Name")
        End Set
    End Property

    Public Property State As String
        Get
            Return _strState
        End Get
        Set(ByVal value As String)
            _strState = value
            If Not String.IsNullOrEmpty(_strState) Then
                _strState = _strState.ToUpper
            End If
            OnPropertyChanged("State")
        End Set
    End Property

    Public Property Email As String
        Get
            Return _strEmail
        End Get
        Set(ByVal value As String)
            _strEmail = value
            If Not String.IsNullOrEmpty(_strEmail) Then
                _strEmail = _strEmail.ToLower
            End If
            OnPropertyChanged("Email")
        End Set
    End Property

    Public Sub New()

    End Sub

    Protected Sub OnPropertyChanged(ByVal strPropertyName As String)
        If Me.PropertyChangedEvent IsNot Nothing Then
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(strPropertyName))
        End If
    End Sub

End Class
